/*
** CALLED_ID.C
**
** Modulo de traslacion de called_id a nombres.
**
**
** (c) 1.997-99 Jesus Cea Avion
** jcea@argo.es
** http://www.argo.es/~jcea/
** http://www.argo.es/~jcea/artic/radius02.htm
**
** Lea las condiciones de uso y distribucion
** en el fichero "COPYING".
**
**
** 12/Jul/99 Primera version de este modulo.
*/

#include <stdlib.h>
#include "called_id.h"
#include "called_id2.h"

/*
** Para regenerar los ficheros ejecutamos lo siguiente:
**
** Luego hay que acordarse de revisar los acentos, etc
** Tambien marcar convenientemente el nodo generico para los que no tienen.

( # Infovia Plus http://www.telefonica-data.com/
echo "/""*"
echo "** CALLED_ID_INFOVIA_PLUS_C"
echo "** Fichero generado automaticamente"
echo "*""/"
echo
echo "#include <stdlib.h>"
echo "#include \"called_id2.h\""
echo 
echo "t2n called_id_infovia_plus[]={"
awk 'a==1 {b=$0} a==2 {print "{\""$0"\",\"Infov&iacute;a Plus - "b"\"},"; a=-1} {a++}' | \
  sed 's/\.//g' | tr -s " " | sed 's/\" \([0-9]\)/\"\1/' | sed 's/ (.*)//g'
echo "{NULL,NULL}};"
echo
) > called_id_infovia_plus.c

( # Interpista http://www.bt.es/prodyser/ip/interp6.htm
echo "/""*"
echo "** CALLED_ID_INTERPISTA_C"
echo "** Fichero generado automaticamente"
echo "*""/"
echo
echo "#include <stdlib.h>"
echo "#include \"called_id2.h\""
echo
echo "t2n called_id_interpista[]={"
awk 'a==0 {b=$0} a==1 {print "{\""$0"\",\"Interpista - "b"\"},"; a=-1} {a++}' | \
  sed 's/\.//g' | tr -s " " | sed 's/\" \([0-9]\)/\"\1/' | sed 's/ (.*)//g'
echo "{NULL,NULL}};"
echo
) > called_id_interpista.c

( # Retenet http://www.iddeo.es/retenet/mapanodosmapa.htm
echo "/""*"
echo "** CALLED_ID_RETENET_C"
echo "** Fichero generado automaticamente"
echo "*""/"
echo
echo "#include <stdlib.h>"
echo "#include \"called_id2.h\""
echo
echo "t2n called_id_retenet[]={"
sed 's-<option>--g' | sed 's-</option>--g' | \
  awk '{a="";for(b=1;b<NF;b++) a=a" "$b; print "{\""$NF"\",\"Retenet - "a"\"},"}' | \
  sed 's/\.//g' | tr -s " " | sed 's/\" \([0-9]\)/\"\1/' | sed 's/ (.*)//g'
echo "{NULL,NULL}};"
echo
) > called_id_retenet.c

*/

static char *busca(char *telefono, t2n *red)
{
  while(red->numero!=NULL)
  {
    if(!strcmp(telefono,red->numero)) return red->nombre;
    red++;
  }
  return NULL;
}

char *telefono2nombre(char *telefono) {
char *p;

  p=busca(telefono,called_id_infovia_plus);
  if(p!=NULL) return p;
  p=busca(telefono,called_id_interpista);
  if(p!=NULL) return p;
  p=busca(telefono,called_id_retenet);
  if(p!=NULL) return p;
  p=busca(telefono,called_id_nodo_local);
  if(p!=NULL) return p;

  return p;
}
